-- constants
local _G = getfenv(0)
local addon = CreateFrame("CheckButton", "ncHoverFocusButton", nil, "SecureActionButtonTemplate")
local defaults = {modifier="alt",button=1}
local arena = {ArenaEnemyFrame1,ArenaEnemyFrame2,ArenaEnemyFrame3,ArenaEnemyFrame4,ArenaEnemyFrame5}
local frames = {PlayerFrame,PetFrame,PartyMemberFrame1,PartyMemberFrame2,PartyMemberFrame3,PartyMemberFrame4,PartyMemberFrame1PetFrame,PartyMemberFrame2PetFrame,PartyMemberFrame3PetFrame,PartyMemberFrame4PetFrame,TargetFrame,TargetFrameToT,FocusFrame,FocusFrameToT,Boss1TargetFrame,Boss2TargetFrame,Boss3TargetFrame,Boss4TargetFrame}

-- functions
local function inject(f)
	if not (f and f.SetAttribute) then return end
	if ncHoverFocusDB then f:SetAttribute(ncHoverFocusDB.modifier.."-type"..ncHoverFocusDB.button, "focus") else tinsert(frames, f) end
end
local function injectall()
	for _, f in next, frames do inject(f) end
	SetOverrideBindingClick(addon, true, ncHoverFocusDB.modifier.."-BUTTON"..ncHoverFocusDB.button, "ncHoverFocusButton")
end
local function hook(_, name, _, template)
	if template~="SecureUnitButtonTemplate" then return end
	inject(_G[name])
end
local function printhelp()
	print("ncHoverFocus")
	print("/nchf mod [arg] - Changes the modifier key to arg. Arg must be either \"alt\", \"ctrl\" or \"shift\".")
	print("/nchf button [num] - Changes the focus button to button num. For more help type /nchf button help.")
	print("/nchf reset - Resets all config to the default.")
end
local function slashcmd(s)
	s = tostring(s)
	if not s or s=="" then printhelp() return end
	s, arg = string.split(" ", string.lower(s))
	if s=="mod" and arg then
		if arg=="alt" or arg=="ctrl" or arg=="shift" then
			ncHoverFocusDB.modifier = arg
			injectall()
		else
			print("Argument must be either \"alt\", \"ctrl\" or \"shift\".")
		end
	elseif s=="mod" then
		print(format("The modifier key is currently %s.", ncHoverFocusDB.modifier))
	elseif s=="button" and tonumber(arg) then
		ncHoverFocusDB.button = tonumber(arg)
		injectall()
	elseif s=="button" and arg then
		print("The argument must be a number. Each number represents an own mousebutton:")
		print("1 = Left Mouse Button")
		print("2 = Right Mouse Button")
		print("3 = Middle Mouse Button")
		print("Depending on your mouse you may have more buttons, experiment with the numbers.")
	elseif s=="button" then
		print(format("The button is currently %s.", ncHoverFocusDB.button))
	elseif s=="reset" then
		ncHoverFocusDB = defaults
		injectall()
	else
		printhelp()
	end
end

-- main
hooksecurefunc("CreateFrame", hook)
addon:SetAttribute("type1", "macro")
addon:SetAttribute("macrotext", "/focus mouseover")
SLASH_NCHOVERFOCUS1 = "/nchf"
SLASH_NCHOVERFOCUS2 = "/nchoverfocus"
SlashCmdList.NCHOVERFOCUS = slashcmd

-- init
addon:SetScript("OnEvent", function(_, _, arg)
	if arg=="!ncHoverFocus" then
		ncHoverFocusDB = ncHoverFocusDB or defaults
		injectall()
	elseif arg=="Blizzard_ArenaUI" then
		for _, f in next, arena do inject(f) end
		addon:SetScript("OnEvent", nil)
		addon:UnregisterEvent("ADDON_LOADED")
	end
end)
addon:RegisterEvent("ADDON_LOADED")